"use strict";
var ShopifyCoreModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ShopifyCoreModule = void 0;
const tslib_1 = require("tslib");
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const shopify_api_1 = require("@shopify/shopify-api");
const core_constants_1 = require("./core.constants");
const core_providers_1 = require("./core.providers");
let ShopifyCoreModule = ShopifyCoreModule_1 = class ShopifyCoreModule {
    constructor(moduleRef) {
        this.moduleRef = moduleRef;
    }
    static forRoot(options) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            return {
                module: ShopifyCoreModule_1,
                global: true,
                providers: [{ provide: core_constants_1.SHOPIFY_CORE_OPTIONS, useValue: options }],
                exports: [core_constants_1.SHOPIFY_CORE_OPTIONS],
            };
        });
    }
    static forRootAsync(options) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            return {
                module: ShopifyCoreModule_1,
                global: true,
                imports: options.imports || [],
                providers: [...(0, core_providers_1.createShopifyCoreAsyncOptionsProviders)(options)],
                exports: [core_constants_1.SHOPIFY_CORE_OPTIONS],
            };
        });
    }
    onModuleInit() {
        const options = this.moduleRef.get(core_constants_1.SHOPIFY_CORE_OPTIONS);
        shopify_api_1.default.Context.initialize({
            API_KEY: options.apiKey,
            API_SECRET_KEY: options.apiSecret,
            API_VERSION: options.apiVersion,
            SCOPES: options.scopes,
            HOST_NAME: options.hostName,
            IS_EMBEDDED_APP: options.isEmbeddedApp,
            SESSION_STORAGE: options.sessionStorage,
        });
    }
};
ShopifyCoreModule = ShopifyCoreModule_1 = tslib_1.__decorate([
    (0, common_1.Module)({}),
    tslib_1.__metadata("design:paramtypes", [core_1.ModuleRef])
], ShopifyCoreModule);
exports.ShopifyCoreModule = ShopifyCoreModule;
//# sourceMappingURL=core.module.js.map